﻿using System;

namespace Graph
{
    public struct Token
    {
        private TokenType _Type;
        private double _Number;
        private int _Line;
        private string _Word;

        public Token(string word, int line)
        {
            _Type = TokenType.Error;
            _Number = 0;
            _Line = line;
            _Word = word;

            if (word == "u")
                _Type = TokenType.U;
            else if (word == "v")
                _Type = TokenType.V;
            else if (word == "x")
                _Type = TokenType.X;
            else if (word == "y")
                _Type = TokenType.Y;
            else if (word == "z")
                _Type = TokenType.Z;
            else if (word == "+")
                _Type = TokenType.Plus;
            else if (word == "-")
                _Type = TokenType.Minus;
            else if (word == "*")
                _Type = TokenType.Times;
            else if (word == "/")
                _Type = TokenType.Divide;
            else if (word == "^")
                _Type = TokenType.Pow;
            else if (word == "=")
                _Type = TokenType.Eq;
            else if (word == "sin")
                _Type = TokenType.Sin;
            else if (word == "cos")
                _Type = TokenType.Cos;
            else if (word == "tan")
                _Type = TokenType.Tan;
            else if (word == "asin")
                _Type = TokenType.ASin;
            else if (word == "acos")
                _Type = TokenType.ACos;
            else if (word == "atan")
                _Type = TokenType.ATan;
            else if (word == "sqrt")
                _Type = TokenType.Sqrt;
            else if (word == "abs")
                _Type = TokenType.Abs;
            else if (word == "log")
                _Type = TokenType.Log;
            else if (word == "ceiling")
                _Type = TokenType.Ceiling;
            else if (word == "floor")
                _Type = TokenType.Floor;
            else if (word == "e")
                _Type = TokenType.E;
            else if (word == "pi")
                _Type = TokenType.PI;
            else if (word == "(")
                _Type = TokenType.LParen;
            else if (word == ")")
                _Type = TokenType.RParen;
            else if (word == "min")
                _Type = TokenType.Min;
            else if (word == "max")
                _Type = TokenType.Max;
            else if (word == ",")
                _Type = TokenType.Comma;
            else if (double.TryParse(word, out _Number))
                _Type = TokenType.Number;

            if (_Type == TokenType.Error)
                throw new TokenException("Invalid token", this);
        }

        public TokenType Type
        {
            get { return _Type; }
        }

        public double Number
        {
            get { return _Number; }
        }

        public int Line
        {
            get { return _Line; }
        }

        public string Word
        {
            get { return _Word; }
        }
    }
}
