﻿using System;

namespace Graph
{
    public class Tokenizer
    {
        private string _Text;
        private int _I;
        private int _Line;

        public Tokenizer(string text)
        {
            _Text = text;
            _I = 0;
            _Line = 1;
        }

        public Token Next()
        {
            string word = "";

            while (_I != _Text.Length)
            {
                char c = char.ToLower(_Text[_I++]);

                if (c == '+' || c == '-' || c == '*' || c == '/' || c == '^' || c == '(' || c == ')' || c == ',' || c == '=')
                {
                    if (word != "")
                        _I--;
                    else
                        word = c.ToString();
                    break;
                }
                else if (c <= ' ')
                {
                    if (word != "")
                    {
                        _I--;
                        break;
                    }
                    if (c == '\n')
                        _Line++;
                }
                else
                    word += c;
            }
            return new Token(word, _Line);
        }

        public Token Peek()
        {
            int i = _I;
            int line = _Line;
            Token token = Next();

            _I = i;
            _Line = line;

            return token;
        }

        public bool HasNext()
        {
            int i = _I;

            while (i != _Text.Length)
            {
                char c = _Text[i++];

                if (c > ' ')
                    return true;
            }
            return false;
        }
    }
}
