﻿using System;

namespace Lib3D
{
    public class LightSceneNode : TransformSceneNode
    {
        public LightSceneNode(GraphicsSystem graphicsSystem)
            : base(graphicsSystem)
        {
            Color = new Vector4(1, 1, 1, 1);
            Attenuation = 0.005f;
        }

        public LightSceneNode(GraphicsSystem graphicsSystem, Vector3 position, Vector4 color, double attenuation)
            : base(graphicsSystem)
        {
            Position = position;
            Color = color;
            Attenuation = attenuation;
        }

        public LightSceneNode(LightSceneNode sceneNode)
            : base(sceneNode)
        {
            Color = sceneNode.Color;
            Attenuation = sceneNode.Attenuation;
        }

        public Vector4 Color
        {
            get;
            set;
        }

        public double Attenuation
        {
            get;
            set;
        }
    }
}
