﻿using System;
using System.Collections.Generic;

namespace Lib3D
{
    public class TextureLoader : IDisposable
    {
        private GraphicsSystem _GraphicsSystem;
        private Dictionary<string, Texture> _Textures;

        public TextureLoader(GraphicsSystem graphicsSystem)
        {
            _GraphicsSystem = graphicsSystem;
            _Textures = new Dictionary<string, Texture>();
        }

        public GraphicsSystem GraphicsSystem
        {
            get { return _GraphicsSystem; }
        }

        public Texture Get(string file)
        {
            file = file.ToLower();
            file = file.Trim();
            if (!_Textures.ContainsKey(file))
                _Textures.Add(file, new Texture(_GraphicsSystem, file));
            return _Textures[file];
        }

        public void Clear()
        {
            foreach (Texture texture in _Textures.Values)
                texture.Dispose();
            _Textures.Clear();
        }

        public void Dispose()
        {
            Clear();
        }
    }
}
